<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
  "http://www.w3.org/TR/html4/loose.dtd">
<html >
<head><title></title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta name="generator" content="TeX4ht (http://www.tug.org/tex4ht/)">
<meta name="originator" content="TeX4ht (http://www.tug.org/tex4ht/)">
<!-- html -->
<meta name="src" content="ScriptingTutorial.tex">
<link rel="stylesheet" type="text/css" href="ScriptingTutorial.css">
</head><body
>



<!--l. 308--><p class="indent" >






<!--l. 312--><p class="indent" >



<!--l. 312--><p class="indent" >



<!--l. 317--><p class="noindent" >__________________________________________________________________________
<span
class="cmbx-12x-x-207">Batch scripting with</span>
<span
class="cmbx-12x-x-207">Themys/ParaView</span>
<!--l. 323--><p class="noindent" >__________________________________________________________________________
<!--l. 328--><p class="noindent" ><span
class="cmr-17">Adapted from the official Paraview Guide</span>
<!--l. 335--><p class="noindent" ><img
src="ScriptingTutorial0x.png" alt="PIC" class="graphics" width="72" height="25" ><!--tex4ht:graphics
name="ScriptingTutorial0x.png" src="images/cc_by.eps"
--><br />
<span
class="cmr-10">This work is licensed under the Creative Commons Attribution 4.0 International License. To</span>
<span
class="cmr-10">view a copy of this license, visit </span><a
href="http://creativecommons.org/licenses/by/4.0/" class="url" ><span
class="cmtt-10">http://creativecommons.org/licenses/by/4.0/</span></a> <span
class="cmr-10">or</span>
<span
class="cmr-10">send a letter to Creative Commons, PO Box 1866, Mountain View, CA 94042, USA.</span>
<!--l. 341--><p class="indent" >   &#x00A0;<br
class="newline" />
<!--l. 343--><p class="noindent" ><img
src="ScriptingTutorial1x.png" alt="PIC" class="graphics" width="160" height="25" ><!--tex4ht:graphics
name="ScriptingTutorial1x.png" src="images/snllineblk.eps"
-->                    <img
src="ScriptingTutorial2x.png" alt="PIC" class="graphics" width="102" height="25" ><!--tex4ht:graphics
name="ScriptingTutorial2x.png" src="images/DOEbwlogo.eps"
-->






   <h2 class="likechapterHead"><a
 id="x1-1000"></a>Contents</h2>
   <div class="tableofcontents">
   &#x00A0;<span class="sectionToc" >1 <a
href="#x1-20001" id="QQ2-1-2">Starting the Python Interpreter</a></span>
<br />   &#x00A0;<span class="sectionToc" >2 <a
href="#x1-30002" id="QQ2-1-3">Tracing ParaView State</a></span>
<br />   &#x00A0;&#x00A0;<span class="subsectionToc" ><a
href="#Q1-1-4">Exercise 2.1: Creating a Python Script Trace</a></span>
<br />   &#x00A0;<span class="sectionToc" >3 <a
href="#x1-40003" id="QQ2-1-5">Macros</a></span>
<br />   &#x00A0;&#x00A0;<span class="subsectionToc" ><a
href="#Q1-1-6">Exercise 3.1: Adding a Macro</a></span>
<br />   &#x00A0;<span class="sectionToc" >4 <a
href="#x1-50004" id="QQ2-1-7">Creating a Pipeline</a></span>
<br />   &#x00A0;&#x00A0;<span class="subsectionToc" ><a
href="#Q1-1-8">Exercise 4.1: Creating and Showing a Source</a></span>
<br />   &#x00A0;&#x00A0;<span class="subsectionToc" ><a
href="#Q1-1-9">Exercise 4.2: Creating and Showing a Filter</a></span>
<br />   &#x00A0;&#x00A0;<span class="subsectionToc" ><a
href="#Q1-1-10">Exercise 4.3: Changing Pipeline Object Properties</a></span>
<br />   &#x00A0;&#x00A0;<span class="subsectionToc" ><a
href="#Q1-1-11">Exercise 4.4: Branching Pipelines</a></span>
<br />   &#x00A0;<span class="sectionToc" >5 <a
href="#x1-60005" id="QQ2-1-12">Active Objects</a></span>
<br />   &#x00A0;&#x00A0;<span class="subsectionToc" ><a
href="#Q1-1-13">Exercise 5.1: Experiment with Active Pipeline Objects</a></span>
<br />   &#x00A0;<span class="sectionToc" >6 <a
href="#x1-70006" id="QQ2-1-14">Online Help</a></span>
<br />   &#x00A0;<span class="sectionToc" >7 <a
href="#x1-80007" id="QQ2-1-15">Reading from Files</a></span>
<br />   &#x00A0;&#x00A0;<span class="subsectionToc" ><a
href="#Q1-1-16">Exercise 7.1: Creating a Reader</a></span>
<br />   &#x00A0;<span class="sectionToc" >8 <a
href="#x1-90008" id="QQ2-1-17">Querying Field Attributes</a></span>
<br />   &#x00A0;&#x00A0;<span class="subsectionToc" ><a
href="#Q1-1-18">Exercise 8.1: Getting Field Information</a></span>
<br />   &#x00A0;<span class="sectionToc" >9 <a
href="#x1-100009" id="QQ2-1-19">Representations</a></span>
<br />   &#x00A0;&#x00A0;<span class="subsectionToc" ><a
href="#Q1-1-20">Exercise 9.1: Coloring Data</a></span>
<br />   &#x00A0;<span class="sectionToc" >10 <a
href="#x1-1100010" id="QQ2-1-21">Views</a></span>
<br />   &#x00A0;&#x00A0;<span class="subsectionToc" ><a
href="#Q1-1-22">Exercise 10.1: Controlling the View</a></span>
<br />   &#x00A0;<span class="sectionToc" >11 <a
href="#x1-1200011" id="QQ2-1-23">Saving Results</a></span>
<br />   &#x00A0;&#x00A0;<span class="subsectionToc" ><a
href="#Q1-1-24">Exercise 11.1: Save Results</a></span>
   </div>







<a
 id="dx1-1001"></a>
<!--l. 4--><p class="indent" >   Python scripting can be leveraged in two ways within ParaView. First, Python
scripts can automate the setup and execution of visualizations by performing the
same actions as a user at the GUI. Second, Python scripts can be run inside
pipeline objects, thereby performing parallel visualization algorithms.
This tutorial describes the first mode, batch scripting for automating the
visualization.
<!--l. 11--><p class="indent" >   Batch scripting is a good way to automate mundane or repetitive tasks, but it
is also a critical component when using ParaView in situations where
the GUI is undesired or unavailable. The automation of Python scripts
allows you to leverage ParaView as a scalable parallel post-processing
framework. We are also leveraging Python scripting to establish <span
class="cmti-12">in situ</span>
computation within simulation code (ParaView supports an <span
class="cmti-12">in situ </span>library called
<a
 id="dx1-1002"></a><a
 id="dx1-1003"></a><span
class="cmbx-12">Catalyst</span>).
<!--l. 19--><p class="indent" >   This tutorial gives only a brief introduction to Python scripting. More
comprehensive documentation on scripting is given in the <span
class="cmti-12">ParaView User&#8217;s</span>
<span
class="cmti-12">Guide</span>. There are also further links on ParaView&#8217;s documentation web page
(<a
href="http://www.paraview.org/documentation" >http://www.paraview.org/documentation</a>) including a complete reference to the
ParaView Python API.
   <h3 class="sectionHead"><span class="titlemark">1   </span> <a
 id="x1-20001"></a>Starting the Python Interpreter</h3>
<!--l. 29--><p class="noindent" >There are many ways to invoke the Python interpreter. The method you use
depends on how you are using the scripting. The easiest way to get a python
interpreter, and the method we use in this tutorial, is to select <span
class="cmss-12">View </span><span
class="cmsy-10x-x-120">&#x2192; </span><span
class="cmss-12">Python</span>
<span
class="cmss-12">Shell </span>from the menu. This will bring up a dialog box containing controls for
ParaView&#8217;s Python shell. This is the Python interpreter, where you directly
control ParaView via the commands described later. For convenience in typing,
ParaView&#8217;s Python shell supports tab completion and history browsing with the
up and down keys.
<div class="center"
>
<!--l. 36--><p class="noindent" >



<!--l. 37--><p class="noindent" ><img
src="ScriptingTutorial3x.png" alt="PIC" class="graphics" width="822" height="433" ><!--tex4ht:graphics
name="ScriptingTutorial3x.png" src="images/PythonShellDialog.eps"
--></div>
<!--l. 40--><p class="indent" >   If you are most interested in getting started on writing scripts, feel free to
skip to the next section past the discussion of the other ways to invoke
scripting.
<!--l. 44--><p class="indent" >   ParaView comes with two command line programs that execute Python
scripts: <span
class="cmtt-12">pvpython</span><a
 id="dx1-2001"></a> and <span
class="cmtt-12">pvbatch</span><a
 id="dx1-2002"></a>. They are similar to the <span
class="cmtt-12">python</span><a
 id="dx1-2003"></a> executable that
comes with Python distributions in that they accept Python scripts either from



the command line or from a file and they feed the scripts to the Python
interpreter.
<!--l. 50--><p class="indent" >   The difference between <span
class="cmtt-12">pvpython</span><a
 id="dx1-2004"></a> and <span
class="cmtt-12">pvbatch</span><a
 id="dx1-2005"></a> is subtle and has to do with
the way they establish the visualization service. <span
class="cmtt-12">pvpython</span><a
 id="dx1-2006"></a> is roughly equivalent to
the <span
class="cmtt-12">paraview</span><a
 id="dx1-2007"></a> client GUI with the GUI replaced with the Python interpreter. It is
a serial application that connects to a ParaView server (which can be either
builtin or remote). <span
class="cmtt-12">pvbatch</span><a
 id="dx1-2008"></a> is roughly equivalent to <span
class="cmtt-12">pvserver</span><a
 id="dx1-2009"></a> except that
commands are taken from a Python script rather than from a socket connection to
a ParaView client. It is a parallel application that can be launched with <span
class="cmtt-12">mpirun</span><a
 id="dx1-2010"></a>
(assuming it was compiled with MPI), but it cannot connect to another
server; it is its own server. In general, you should use <span
class="cmtt-12">pvpython</span><a
 id="dx1-2011"></a> if you will
be using the interpreter interactively and <span
class="cmtt-12">pvbatch</span><a
 id="dx1-2012"></a> if you are running in
parallel.
<!--l. 65--><p class="indent" >   It is also possible to use the ParaView Python modules from programs outside
of ParaView. This can be done by pointing the <span
class="cmtt-12">PYTHONPATH </span>environment variable
to the location of the ParaView libraries and Python modules and pointing the
<span
class="cmtt-12">LD</span><span
class="cmtt-12">_LIBRARY</span><span
class="cmtt-12">_PATH </span>(on Unix/Linux), <span
class="cmtt-12">DYLD</span><span
class="cmtt-12">_LIBRARY</span><span
class="cmtt-12">_PATH </span>(on Mac), or <span
class="cmtt-12">PATH </span>(on
Windows) environment variable to the ParaView libraries. Running the Python
script this way allows you to take advantage of third-party applications such as
IDLE. For more information on setting up your environment, consult the
ParaView Wiki.
<!--l. 75--><p class="noindent" >
   <h3 class="sectionHead"><span class="titlemark">2   </span> <a
 id="x1-30002"></a>Tracing ParaView State</h3>
<a
 id="dx1-3001"></a>
<!--l. 80--><p class="noindent" >Before diving into the depths of the Python scripting features, let us take a
moment to explore the automated facilities for creating Python scripts. The
ParaView GUI&#8217;s Python <span
class="cmss-12">Trace</span><a
 id="dx1-3002"></a> feature allows one to very easily create Python
scripts for many common tasks. To use <span
class="cmss-12">Trace</span>, one simply begins a trace
recording via <span
class="cmss-12">Start Trace</span>, found in the <span
class="cmss-12">Tools </span>menu, and ends a trace recording
via <span
class="cmss-12">Stop Trace</span>, also found in the <span
class="cmss-12">Tools </span>menu. This produces a Python
script that reconstructs the actions taken in the GUI. That script contains
the same set of operations that we are about to describe. As such, <span
class="cmss-12">Trace</span>
recordings are a good resource when you are trying to figure out how to
do some action via the Python interface, and conversely the following
descriptions will help in understanding the contents of any given <span
class="cmss-12">Trace</span>



script.
<a
 id="x1-3003r1"></a>
<!--l. 94--><p class="noindent" ><span
class="cmbx-12x-x-120">Exercise 2.1: Creating a Python Script Trace</span> <a
 id="x1-3004"></a> <a
 id="Q1-1-4"></a>            <br
class="newline" />
<!--l. 97--><p class="indent" >
      <ol  class="enumerate1" >
      <li
  class="enumerate" id="x1-3006x1">Click the <span
class="cmss-12">Start Trace </span>option in the <span
class="cmss-12">Tools </span>menu.
      </li>
      <li
  class="enumerate" id="x1-3008x2">A dialog box with options for the trace is presented. We will discuss
      the meaning of these options later. For now, just click <span
class="cmss-12">OK</span>.
      </li>
      <li
  class="enumerate" id="x1-3010x3">Build a simple pipeline in the main ParaView GUI. For example, create
      a sphere source and then clip it.
      </li>
      <li
  class="enumerate" id="x1-3012x4">Click <span
class="cmss-12">Stop Trace </span>in the <span
class="cmss-12">Tools </span>menu.
      </li>
      <li
  class="enumerate" id="x1-3014x5">An  editing  window  will  open  populated  with  a  Python  script  that
      replicates the operations you just made.</li></ol>
<!--l. 110--><p class="indent" >   Even if you have not been exposed to ParaView&#8217;s Python bindings, the
commands being performed in the traced script should be familiar. Once saved to
your hard drive, you can of course edit the script with your favorite editor. The
final script can be interpreted by the <span
class="cmtt-12">pvpython</span><a
 id="dx1-3015"></a> or <span
class="cmtt-12">pvbatch</span><a
 id="dx1-3016"></a> program for totally
automated visualization. It is also possible to run this script in the GUI. The
<span
class="cmss-12">Python Shell </span>dialog has a <span
class="cmss-12">Run Script </span>button that invokes a saved script.
                                                                         <span
class="msam-10x-x-120">&#x2666;</span>
<!--l. 120--><p class="indent" >   It should be noted that there is also a way to capture the current ParaView
state as a Python script without tracing actions. Simply select <span
class="cmss-12">Save State... </span>from
the ParaView <span
class="cmss-12">File </span>menu and choose to save as a Python .py state file (as opposed
to a ParaView .pvsm state file). We will not have an exercise on state Python
scripts, but suffice it to say they can be used in much the same way as traced



Python scripts. You are welcome to experiment with this feature as you
like.
<div class="center"
>
<!--l. 128--><p class="noindent" >



<!--l. 129--><p class="noindent" ><img
src="ScriptingTutorial4x.png" alt="PIC" class="graphics" width="657" height="475" ><!--tex4ht:graphics
name="ScriptingTutorial4x.png" src="images/TraceOptions.eps"
--></div>
<!--l. 132--><p class="indent" >   As noted earlier in the exercise, Python tracing has some options that are
presented in a dialog box before the tracing starts. The first option selections
what properties are saved to the trace. Some properties you explicitly set through



the GUI, such as a value entered in a GUI widget. Some properties are set
internally by the ParaView application, such as the initial position of a clip plane
based on the bounds of the object it is being applied to. Many other properties
are left at some default value. You can choose one of the following classes of
properties to save:
      <dl class="description"><dt class="description">
<span
class="cmssbx-10x-x-120">all properties</span> </dt><dd
class="description">Traces the values of all properties even if they remain at the
      default. This can be helpful to introspect all possible properties or to
      ensure a consistent state regardless of the settings for other users. This
      also yields a very verbose output that can be hard to read.
      </dd><dt class="description">
<span
class="cmssbx-10x-x-120">any *modified* properties</span> </dt><dd
class="description">Ignores any properties that do not change from
      their defaults. This is a good option for most use cases.
      </dd><dt class="description">
<span
class="cmssbx-10x-x-120">only *user-modified* properties</span> </dt><dd
class="description">Ignores   any   properties   that   are   not
      explicitly set by the user. Traces of this nature rely on any internally
      set properties being reapplied when the script is run.</dd></dl>
<!--l. 154--><p class="indent" >   The next option has to do with supplemental objects that are managed by the
ParaView GUI (or client) rather than in the server&#8217;s state. Check this box to
capture all of the state associated with these objects, which includes color maps,
color bars, and other annotation.
<!--l. 159--><p class="indent" >   Finally, ParaView provides the option to show the trace file as it is being
generated. This can be a helpful option to use when learning what Python
commands can be used to replicate particular actions in the ParaView
GUI.
<a
 id="dx1-3017"></a>
<!--l. 165--><p class="noindent" >
   <h3 class="sectionHead"><span class="titlemark">3   </span> <a
 id="x1-40003"></a>Macros</h3>
<a
 id="dx1-4001"></a>
<a
 id="dx1-4002"></a>
<!--l. 171--><p class="noindent" >A simple but powerful way to customize the behavior of ParaView is to add your
Python script as a <a
 id="dx1-4003"></a><span
class="cmbx-12">macro</span>. A macro is simply an automated script that can be



invoked through its button in a toolbar or its entry in the menu bar. Any Python
script can be assigned to a macro.
<a
 id="x1-4004r1"></a>
<!--l. 177--><p class="noindent" ><span
class="cmbx-12x-x-120">Exercise 3.1: Adding a Macro</span> <a
 id="x1-4005"></a> <a
 id="Q1-1-6"></a>                                <br
class="newline" />This exercise is a continuation of Exercise&#x00A0;<a
href="#x1-3003r1">2.1<!--tex4ht:ref: ex:CreatingAPythonScriptTrace --></a>. You will need to finish that
exercise before beginning this one. You should have the editing window containing
the Python script created in Exercise&#x00A0;<a
href="#x1-3003r1">2.1<!--tex4ht:ref: ex:CreatingAPythonScriptTrace --></a> open.
<!--l. 185--><p class="indent" >
      <ol  class="enumerate1" >
      <li
  class="enumerate" id="x1-4007x1">In the menu bar (of the editing window), select <span
class="cmss-12">File </span><span
class="cmsy-10x-x-120">&#x2192; </span><span
class="cmss-12">Save As Macro...</span>.
      </li>
      <li
  class="enumerate" id="x1-4009x2">Choose a descriptive name for the macro file and save it in the default
      directory provided by the browser. You should now see your macro on
      the Macro toolbar at the top of the ParaView GUI.</li></ol>
<!--l. 194--><p class="indent" >   At this point, you should now see your macro added to the toolbars. By
default, macro toolbar buttons are placed in the middle row all the way
to the right. If you are short on space in your GUI, you may need to
move toolbars around to see it. You will also see that your macro has
been added to the <span
class="cmss-12">Tools </span>menu in Themys (and <span
class="cmss-12">Macro </span>menu in paraview
mode).
<!--l. 200--><p class="indent" >
      <ol  class="enumerate1" >
      <li
  class="enumerate" id="x1-4011x3">Close the Python editor window.
      </li>
      <li
  class="enumerate" id="x1-4013x4">Delete the pipeline you have created by either selecting <span
class="cmss-12">reset session</span>
      from the <span
class="cmss-12">Edit </span>menu.
      </li>
      <li
  class="enumerate" id="x1-4015x5">Activate your macro by clicking on the toolbar button or selecting it
      in the <span
class="cmss-12">Tools </span>menu.</li></ol>
<!--l. 208--><p class="indent" >   In this example our macro created something from scratch. This is helpful if
you often load some data in the same way every time. You can also trace the



creation of filters that are applied to existing data. A macro from a trace of this
nature allows you to automate the same visualization on different data.
                                                                         <span
class="msam-10x-x-120">&#x2666;</span>
<a
 id="dx1-4016"></a>
<a
 id="dx1-4017"></a>
<!--l. 218--><p class="noindent" >
   <h3 class="sectionHead"><span class="titlemark">4   </span> <a
 id="x1-50004"></a>Creating a Pipeline</h3>
<!--l. 221--><p class="noindent" >As described in the previous two sections, the ParaView GUI&#8217;s Python <span
class="cmss-12">Trace</span>
feature provides a simple mechanism to create scripts. In this section we will begin
to describe the basic bindings for ParaView scripting. This is important
information in building Python scripts, but you can always fall back on producing
traces with the GUI.
<!--l. 227--><p class="indent" >   The first thing any ParaView Python script must do is load the <span
class="cmtt-12">paraview.simple</span>
module. This is done by invoking
   <div class="fancyvrb" id="fancyvrb1"><a
 id="x1-5002r1"></a><span
class="cmtt-12">from</span><span
class="cmtt-12">&#x00A0;paraview.simple</span><span
class="cmtt-12">&#x00A0;import</span><span
class="cmtt-12">&#x00A0;*</span></div>
<!--l. 232--><p class="noindent" >In general, this command needs to be invoked at the beginning of any ParaView
batch Python script. This command is automatically invoked for you when you
bring up the scripting dialog in ParaView, but you must add it yourself when
using the Python interpreter in other programs (including <span
class="cmtt-12">pvpython</span><a
 id="dx1-5003"></a> and
<span
class="cmtt-12">pvbatch</span><a
 id="dx1-5004"></a>).
<a
 id="dx1-5005"></a>
<!--l. 240--><p class="indent" >   The <span
class="cmtt-12">paraview.simple </span>module defines a function for every source, reader,
filter, and writer defined in ParaView. The function will be the same name as
shown in the GUI menus with spaces and special characters removed. For
example, the <a
 id="dx1-5006"></a><a
 id="dx1-5007"></a><span
class="cmtt-12">Sphere </span>function corresponds to <span
class="cmss-12">Sources </span><span
class="cmsy-10x-x-120">&#x2192; </span><span
class="cmss-12">Sphere </span>in the GUI and
the <a
 id="dx1-5008"></a><a
 id="dx1-5009"></a><span
class="cmtt-12">PlotOverLine </span>function corresponds to <span
class="cmss-12">Filters </span><span
class="cmsy-10x-x-120">&#x2192; </span><span
class="cmss-12">Plot Over Line</span>. Each
function creates a pipeline object, which will show up in the pipeline browser
(with the exception of writers), and returns an object that is a <a
 id="dx1-5010"></a><span
class="cmbx-12">proxy</span><a
 id="dx1-5011"></a>
that can be used to query and manipulate the properties of that pipeline
object.
<!--l. 251--><p class="indent" >   There are also several other functions in the <span
class="cmtt-12">paraview.simple </span>module that



perform other manipulations. For example, the pair of functions <a
 id="dx1-5012"></a><a
 id="dx1-5013"></a><span
class="cmtt-12">Show </span>and <a
 id="dx1-5014"></a><a
 id="dx1-5015"></a><span
class="cmtt-12">Hide</span>
turn on and off, respectively, the visibility of a pipeline object in a view. The
<a
 id="dx1-5016"></a><a
 id="dx1-5017"></a><span
class="cmtt-12">Render </span>function causes a view to be redrawn.
<!--l. 257--><p class="indent" >   To obtain a concise list of the functions available in <span
class="cmtt-12">paraview.simple</span>, invoke
<span
class="cmtt-12">dir(paraview.simple)</span>. Alternatively, as explained in Section&#x00A0;<a
href="#x1-70006">6<!--tex4ht:ref: sec:OnlineHelp --></a> you can get a
verbose listing via <span
class="cmtt-12">help(paraview.simple)</span>.
<a
 id="x1-5018r1"></a>
<!--l. 262--><p class="noindent" ><span
class="cmbx-12x-x-120">Exercise 4.1: Creating and Showing a Source</span> <a
 id="x1-5019"></a> <a
 id="Q1-1-8"></a>            <br
class="newline" />We are going to start a fresh visualization, so if you have been following along
with the exercises so far, now is a good time to reset ParaView. The easiest way
to do this is to select <span
class="cmss-12">Edit </span><span
class="cmsy-10x-x-120">&#x2192; </span><span
class="cmss-12">Reset Session</span><a
 id="dx1-5020"></a> from the menu or hit <img
src="ScriptingTutorial5x.png" alt="PIC" class="graphics" width="21" height="21" ><!--tex4ht:graphics
name="ScriptingTutorial5x.png" src="images/icons/resetClock.eps"
--> on the
toolbar in paraview mode.
<!--l. 267--><p class="indent" >   If you have not already done so, open the Python shell in the ParaView
GUI by selecting <span
class="cmss-12">View </span><span
class="cmsy-10x-x-120">&#x2192; </span><span
class="cmss-12">Python Shell </span>from the menu. You will notice
that
   <div class="fancyvrb" id="fancyvrb2"><a
 id="x1-5022r1"></a><span
class="cmtt-12">from</span><span
class="cmtt-12">&#x00A0;paraview.simple</span><span
class="cmtt-12">&#x00A0;import</span><span
class="cmtt-12">&#x00A0;*</span></div>
<!--l. 273--><p class="noindent" >has been added for you.
<!--l. 275--><p class="indent" >   Create and show a <span
class="cmss-12">Sphere </span>source by typing the following in the Python
shell.
   <div class="fancyvrb" id="fancyvrb3"><a
 id="x1-5024r1"></a><span
class="cmtt-12">sphere</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;Sphere()</span><br class="fancyvrb" /><a
 id="x1-5026r2"></a><span
class="cmtt-12">Show()</span><br class="fancyvrb" /><a
 id="x1-5028r3"></a><span
class="cmtt-12">Render()</span><br class="fancyvrb" /><a
 id="x1-5030r4"></a><span
class="cmtt-12">ResetCamera()</span></div>
<!--l. 284--><p class="indent" >   The <a
 id="dx1-5031"></a><a
 id="dx1-5032"></a><span
class="cmtt-12">Sphere </span>command creates a sphere pipeline object. Once it is
executed you will see an item in the pipeline browser created. We save a
<a
 id="dx1-5033"></a>proxy to the pipeline object in the variable <span
class="cmtt-12">sphere</span>. We are not using this
variable (yet), but it is good practice to save references to your pipeline
objects.
<!--l. 290--><p class="indent" >   The subsequent <a
 id="dx1-5034"></a><a
 id="dx1-5035"></a><span
class="cmtt-12">Show </span>command turns on visibility of this object in the view,
and the subsequent <a
 id="dx1-5036"></a><a
 id="dx1-5037"></a><span
class="cmtt-12">Render </span>causes the results to be seen. Finally, although the
ParaView GUI automatically adjusts the camera to data shown for the first time,
the Python scripting does not. The call to <a
 id="dx1-5038"></a><a
 id="dx1-5039"></a><span
class="cmtt-12">ResetCamera </span>performs this automatic
camera adjustment if necessary.
<!--l. 297--><p class="indent" >   At this point you can interact directly with the GUI again. Try changing the
camera angle in the view with the mouse.                                           <span
class="msam-10x-x-120">&#x2666;</span>



<a
 id="x1-5040r2"></a>
<!--l. 301--><p class="noindent" ><span
class="cmbx-12x-x-120">Exercise 4.2: Creating and Showing a Filter</span> <a
 id="x1-5041"></a> <a
 id="Q1-1-9"></a>             <br
class="newline" />Creating filters is almost identical to creating sources. By default, the last created
pipeline object will be set as the input to the newly created filter, much like when
creating filters in the GUI.
<!--l. 307--><p class="indent" >   This exercise is a continuation of Exercise&#x00A0;<a
href="#x1-5018r1">4.1<!--tex4ht:ref: ex:CreatingAndShowingASource --></a>. You will need to finish that
exercise before beginning this one.
<!--l. 311--><p class="indent" >   Type in the following script in the Python shell that hides the sphere and then
adds the shrink filter to the sphere and shows that.
<a
 id="dx1-5042"></a>
<a
 id="dx1-5043"></a>
<a
 id="dx1-5044"></a>
<a
 id="dx1-5045"></a>
<a
 id="dx1-5046"></a>
<a
 id="dx1-5047"></a>
<a
 id="dx1-5048"></a>
<a
 id="dx1-5049"></a>
<!--l. 315--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb4"><a
 id="x1-5051r1"></a><span
class="cmtt-12">Hide()</span><br class="fancyvrb" /><a
 id="x1-5053r2"></a><span
class="cmtt-12">shrink</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;Shrink()</span><br class="fancyvrb" /><a
 id="x1-5055r3"></a><span
class="cmtt-12">Show()</span><br class="fancyvrb" /><a
 id="x1-5057r4"></a><span
class="cmtt-12">Render()</span></div>
<!--l. 322--><p class="indent" >   The sphere should be replaced with the output of the <a
 id="dx1-5058"></a><a
 id="dx1-5059"></a><span
class="cmtt-12">Shrink </span>filter, which
makes all of the polygons smaller to give the mesh an exploded type of
appearance.                                                                                  <span
class="msam-10x-x-120">&#x2666;</span>
<!--l. 327--><p class="indent" >   So far as we have built pipelines we have accepted the default parameters for
the pipeline objects. As we have seen in the exercises of the main tutorial, it is
common to have to modify the parameters of the objects using the properties
panel.
<!--l. 332--><p class="indent" >   In Python scripting, we use the <a
 id="dx1-5060"></a><span
class="cmbx-12">proxy</span><a
 id="dx1-5061"></a> returned from the creation functions to
manipulate the pipeline objects. These proxies are in fact Python objects with
class attributes that correspond to the same properties you set in the properties
panel. They have the same names as those in the properties panel with spaces and
other illegal characters removed. Use <a
 id="dx1-5062"></a><a
 id="dx1-5063"></a><span
class="cmtt-12">dir(variable) </span>or <a
 id="dx1-5064"></a><a
 id="dx1-5065"></a><span
class="cmtt-12">help(variable) </span>to get a



list of all attributes on any variable that you have access to. In most
cases, simply assign values to an object&#8217;s attributes in order to change
them.
<a
 id="x1-5066r3"></a>
<!--l. 342--><p class="noindent" ><span
class="cmbx-12x-x-120">Exercise 4.3: Changing Pipeline Object Properties</span> <a
 id="x1-5067"></a> <a
 id="Q1-1-10"></a>
                                                                          <br
class="newline" />This exercise is a continuation of Exercises <a
href="#x1-5018r1">4.1<!--tex4ht:ref: ex:CreatingAndShowingASource --></a> and <a
href="#x1-5040r2">4.2<!--tex4ht:ref: ex:CreatingAndShowingAFilter --></a>. You will need to finish
those exercises before beginning this one.
<!--l. 349--><p class="indent" >   Recall that we have so far created two Python variables, <span
class="cmtt-12">sphere </span>and <span
class="cmtt-12">shrink</span>,
that are proxies to the corresponding pipeline objects. First, enter the following
command into the Python shell to get a concise listing of all attributes of the
sphere.
<!--l. 354--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb5"><a
 id="x1-5069r1"></a><span
class="cmtt-12">dir(sphere)</span></div>
<!--l. 358--><p class="indent" >   Next, enter the following command into the Python shell to get the current
value of the <span
class="cmss-12">Theta Resolution </span>property of the sphere.
<!--l. 361--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb6"><a
 id="x1-5071r1"></a><span
class="cmtt-12">print</span><span
class="cmtt-12">&#x00A0;sphere.ThetaResolution</span></div>
<!--l. 365--><p class="indent" >   The Python interpreter should respond with the result <span
class="cmtt-12">8</span>. (Note that using the
<span
class="cmtt-12">print </span>keyword, which instructs Python to output the arguments to standard out,
is superfluous here as the Python shell will output the result of any command
anyway.) Let us double the number of polygons around the equator of the sphere
by changing this property.
<!--l. 371--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb7"><a
 id="x1-5073r1"></a><span
class="cmtt-12">sphere.ThetaResolution</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;16</span><br class="fancyvrb" /><a
 id="x1-5075r2"></a><span
class="cmtt-12">Render()</span></div>
<!--l. 376--><p class="indent" >   The shrink filter has only one property, <span
class="cmss-12">Shrink Factor</span>. We can adjust this
factor to make the size of the polygons larger or smaller. Let us change the factor
to make the polygons smaller.
<!--l. 380--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb8"><a
 id="x1-5077r1"></a><span
class="cmtt-12">shrink.ShrinkFactor</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;0.25</span><br class="fancyvrb" /><a
 id="x1-5079r2"></a><span
class="cmtt-12">Render()</span></div>



<!--l. 385--><p class="indent" >   You may have noticed that as you type in Python commands to change the
pipeline object properties, the GUI in the properties panel updates accordingly.
                                                                         <span
class="msam-10x-x-120">&#x2666;</span>
<!--l. 390--><p class="indent" >   So far we have created only non-branching pipelines. This is a simple and
common case and, like many other things in the <span
class="cmtt-12">paraview.simple </span>module, is
designed to minimize the amount of work for the simple and common case but
also provide a clear path to the more complicated cases. As we have built the
non-branching pipeline, ParaView has automatically connected the filter input to
the previously created object so that the script reads like the sequence of
operations it is. However, if the pipeline has branching, we need to be more
specific about the filter inputs.
<a
 id="x1-5080r4"></a>
<!--l. 400--><p class="noindent" ><span
class="cmbx-12x-x-120">Exercise 4.4: Branching Pipelines</span> <a
 id="x1-5081"></a> <a
 id="Q1-1-11"></a>                           <br
class="newline" />This exercise is a continuation of Exercises <a
href="#x1-5018r1">4.1<!--tex4ht:ref: ex:CreatingAndShowingASource --></a> through <a
href="#x1-5066r3">4.3<!--tex4ht:ref: ex:ChangingPipelineObjectProperties --></a>. You will need to
finish Exercises <a
href="#x1-5018r1">4.1<!--tex4ht:ref: ex:CreatingAndShowingASource --></a> and <a
href="#x1-5040r2">4.2<!--tex4ht:ref: ex:CreatingAndShowingAFilter --></a> before beginning this one (Exercise&#x00A0;<a
href="#x1-5066r3">4.3<!--tex4ht:ref: ex:ChangingPipelineObjectProperties --></a> is
optional).
<!--l. 409--><p class="indent" >   Recall that we have so far created two Python variables, <span
class="cmtt-12">sphere </span>and <span
class="cmtt-12">shrink</span>,
that are proxies to the corresponding pipeline objects. We will now add a second
filter to the sphere source that will extract the wireframe from it. Enter the
following in the Python shell.
<a
 id="dx1-5082"></a>
<a
 id="dx1-5083"></a>
<!--l. 415--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb9"><a
 id="x1-5085r1"></a><span
class="cmtt-12">wireframe</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;ExtractEdges(Input=sphere)</span><br class="fancyvrb" /><a
 id="x1-5087r2"></a><span
class="cmtt-12">Show()</span><br class="fancyvrb" /><a
 id="x1-5089r3"></a><span
class="cmtt-12">Render()</span></div>
<!--l. 421--><p class="indent" >   An <span
class="cmss-12">Extract Edges </span>filter is added to the sphere source. You should now see both
the wireframe of the original sphere and the shrunken polygons.
<!--l. 425--><p class="indent" >   Notice that we explicitly set the input for the <span
class="cmss-12">Extract Edges </span>filter by providing
<span
class="cmtt-12">Input=sphere </span>as an argument to the <a
 id="dx1-5090"></a><a
 id="dx1-5091"></a><span
class="cmtt-12">ExtractEdges </span>function. What we are really
doing is setting the <span
class="cmtt-12">Input </span>property upon construction of the object. Although it
would be possible to create the object with the default input, and then set the
input later, it is not recommended. The problem is that not all filters accept all
input. If you initially create a filter with the wrong input, you could get error



messages before you get a chance to change the <span
class="cmtt-12">Input </span>property to the correct
input.
<!--l. 435--><p class="indent" >   The sphere source having two filters connected to its output is an example of
<a
 id="dx1-5092"></a><span
class="cmbx-12">fan out </span>in the pipeline. It is always possible to have multiple filters attached to a
single output. Some filters, but not all, also support having multiple filters
connected to their input. Multiple filters are attached to an input is known as <a
 id="dx1-5093"></a><span
class="cmbx-12">fan</span>
<span
class="cmbx-12">in</span>. In ParaView&#8217;s Python scripting, fan in is handled much like fan out, by
explicitly defining a filter&#8217;s inputs. When setting multiple inputs on a single port
(Filters that have multiple input ports, like <span
class="cmtt-12">ResampleWithDataset</span>, use different
names to distinguish amongst the input properties instead. The ports are typically
called &#8220;Input&#8221; and &#8220;Source&#8221; but consult <span
class="cmss-12">Trace </span>or <a
 id="dx1-5094"></a><a
 id="dx1-5095"></a><span
class="cmtt-12">help </span>to be sure.), simply
set the input to a list of pipeline objects rather than a single one. For
example, let us group the results of the shrink and extract edges filters
using the <span
class="cmss-12">Group Datasets </span>filter. Type the following line in the Python
shell.
<a
 id="dx1-5096"></a>
<a
 id="dx1-5097"></a>
<!--l. 448--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb10"><a
 id="x1-5099r1"></a><span
class="cmtt-12">group</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;GroupDatasets(Input=[shrink,wireframe])</span><br class="fancyvrb" /><a
 id="x1-5101r2"></a><span
class="cmtt-12">Show()</span></div>
<!--l. 453--><p class="indent" >   There is now no longer any reason for showing the shrink and extract edges
filters, so let us hide them. By default, the <a
 id="dx1-5102"></a><a
 id="dx1-5103"></a><span
class="cmtt-12">Show </span>and <a
 id="dx1-5104"></a><a
 id="dx1-5105"></a><span
class="cmtt-12">Hide </span>functions operate on
the last pipeline object created (much like the default input when creating a
filter), but you can explicitly choose the object by giving it as an argument. To
hide the shrink and extract edges filters, type the following in the Python
shell.
<!--l. 460--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb11"><a
 id="x1-5107r1"></a><span
class="cmtt-12">Hide(shrink)</span><br class="fancyvrb" /><a
 id="x1-5109r2"></a><span
class="cmtt-12">Hide(wireframe)</span><br class="fancyvrb" /><a
 id="x1-5111r3"></a><span
class="cmtt-12">Render()</span></div>
                                                                         <span
class="msam-10x-x-120">&#x2666;</span>
<!--l. 467--><p class="indent" >   In the previous exercise, we saw that we could set the <span
class="cmtt-12">Input </span>property by
placing <span
class="cmtt-12">Input=</span><span
class="cmsy-10x-x-120">&#x27E8;</span><span
class="cmti-12">input object</span><span
class="cmsy-10x-x-120">&#x27E9; </span>in the arguments of the creator function. In
general we can set any of the properties at object construction by specifying
<span
class="cmsy-10x-x-120">&#x27E8;</span><span
class="cmti-12">property name</span><span
class="cmsy-10x-x-120">&#x27E9;</span><span
class="cmtt-12">=</span><span
class="cmsy-10x-x-120">&#x27E8;</span><span
class="cmti-12">property value</span><span
class="cmsy-10x-x-120">&#x27E9;</span>. For example, we can set both the <span
class="cmss-12">Theta</span>
<span
class="cmss-12">Resolution </span>and <span
class="cmss-12">Phi Resolution </span>when we create a sphere with a line like
this.



<!--l. 475--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb12"><a
 id="x1-5113r1"></a><span
class="cmtt-12">sphere</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;Sphere(ThetaResolution=360,</span><span
class="cmtt-12">&#x00A0;PhiResolution=180)</span></div>
<!--l. 480--><p class="noindent" >
   <h3 class="sectionHead"><span class="titlemark">5   </span> <a
 id="x1-60005"></a>Active Objects</h3>
<!--l. 483--><p class="noindent" >If you have any experience with the ParaView GUI, then you should
already be familiar with the concept of an active object. As you build and
manipulate visualizations within the GUI, you first have to select an object
in the pipeline browser. Other GUI panels such as the properties panel
will change based on what the active object is. The active object is also
used as the default object to use for some operations such as adding a
filter.
<!--l. 491--><p class="indent" >   The batch Python scripting also understands the concept of the active object.
In fact, when running together, the GUI and the Python interpreter share the
same active object. When you created filters in the previous section, the default
input they were given was actually the active object. When you created a new
pipeline object, that new object became the active one (just like when you create
an object in the GUI).
<!--l. 498--><p class="indent" >   You can get and set the active object with the <a
 id="dx1-6001"></a><a
 id="dx1-6002"></a><span
class="cmtt-12">GetActiveSource </span>and
<a
 id="dx1-6003"></a><a
 id="dx1-6004"></a><span
class="cmtt-12">SetActiveSource </span>functions, respectively. You can also get a list of all pipeline
objects with the <a
 id="dx1-6005"></a><a
 id="dx1-6006"></a><span
class="cmtt-12">GetSources </span>function. When you click on a new object in the
GUI pipeline browser, the active object in Python will change. Likewise, if you
call <a
 id="dx1-6007"></a><a
 id="dx1-6008"></a><span
class="cmtt-12">SetActiveSource </span>in python, you will see the corresponding entry become
highlighted in the pipeline browser.
<a
 id="x1-6009r1"></a>
<!--l. 506--><p class="noindent" ><span
class="cmbx-12x-x-120">Exercise 5.1: Experiment with Active Pipeline Objects</span> <a
 id="x1-6010"></a> <a
 id="Q1-1-13"></a>
                                                                          <br
class="newline" />This exercise is a continuation of the exercises in the previous section.
However, if you prefer you can create any pipeline you want and follow
along.
<!--l. 512--><p class="indent" >   Play with active objects by trying the following.
      <ul class="itemize1">



      <li class="itemize">Get a list of objects by calling <a
 id="dx1-6011"></a><a
 id="dx1-6012"></a><span
class="cmtt-12">GetSources()</span>. Find the sources and
      filters you created in that list.
      </li>
      <li class="itemize">Get the active object by calling <a
 id="dx1-6013"></a><a
 id="dx1-6014"></a><span
class="cmtt-12">GetActiveSource()</span>. Compare that to
      what is selected in the pipeline browser.
      </li>
      <li class="itemize">Select    something    new    in    the    pipeline    browser    and    call
      <span
class="cmtt-12">GetActiveSource() </span>again.
      </li>
      <li class="itemize">Change the active object with the <span
class="cmtt-12">SetActiveSource() </span>function. You
      can use one of the proxy objects you created earlier as an argument to
      <a
 id="dx1-6015"></a><a
 id="dx1-6016"></a><span
class="cmtt-12">SetActiveSource</span>. Observe the change in the pipeline browser.</li></ul>
                                                                         <span
class="msam-10x-x-120">&#x2666;</span>
<!--l. 529--><p class="indent" >   In addition to maintaining an active pipeline object, ParaView Python
scripting also maintains an active view. As a ParaView user, you should also
already be familiar with multiple views and the active view. The active view is
marked in the GUI with a blue border. The Python functions <a
 id="dx1-6017"></a><a
 id="dx1-6018"></a><span
class="cmtt-12">GetActiveView </span>and
<a
 id="dx1-6019"></a><a
 id="dx1-6020"></a><span
class="cmtt-12">SetActiveView </span>allow you to query and change the active view. As with pipeline
objects, the active view is synchronized between the GUI and the Python
interpreter.
<!--l. 538--><p class="noindent" >
   <h3 class="sectionHead"><span class="titlemark">6   </span> <a
 id="x1-70006"></a>Online Help</h3>
<!--l. 541--><p class="noindent" >This tutorial, as well as similar instructions in the ParaView book and Wiki, is
designed to give the key concepts necessary to understand and create
batch Python scripts. The detailed documentation including complete
lists of functions, classes, and properties available is maintained by the
ParaView build process and provided as online help from within the ParaView
application. In this way we can ensure that the documentation is up to
date for whatever version of ParaView you are using and that it is easily
accessible.



<!--l. 550--><p class="indent" >   The ParaView Python bindings make use of the <a
 id="dx1-7001"></a><a
 id="dx1-7002"></a><span
class="cmtt-12">help </span>built-in function.
This function takes as an argument any Python object and returns some
documentation on it. For example, typing
   <div class="fancyvrb" id="fancyvrb13"><a
 id="x1-7004r1"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;help(paraview.simple)</span></div>
<!--l. 556--><p class="noindent" >returns a brief description of the module and then a list of all the functions
included in the module with a brief synopsis of what each one does. For
example
   <div class="fancyvrb" id="fancyvrb14"><a
 id="x1-7006r1"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;help(Sphere)</span><br class="fancyvrb" /><a
 id="x1-7008r2"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;sphere</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;Sphere()</span><br class="fancyvrb" /><a
 id="x1-7010r3"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;help(sphere)</span></div>
<!--l. 564--><p class="noindent" >will first give help on the <a
 id="dx1-7011"></a><a
 id="dx1-7012"></a><span
class="cmtt-12">Sphere </span>function, then use it to create an object, and then
give help on the object that was returned (including a list of all the properties for
the <a
 id="dx1-7013"></a>proxy).
<!--l. 568--><p class="indent" >   Most of the widgets displayed in the properties panel&#8217;s <span
class="cmss-12">Properties </span>group are
automatically generated from the same introspection that builds the Python
classes. (There are a small number of exceptions where a custom panel was
created for better usability.) Thus, if you see a labeled widget in the properties
panel, there is a good chance that there is a corresponding property in the Python
object with the same name.
<!--l. 576--><p class="noindent" >
   <h3 class="sectionHead"><span class="titlemark">7   </span> <a
 id="x1-80007"></a>Reading from Files</h3>
<!--l. 579--><p class="noindent" >The equivalent to opening a file in the ParaView GUI is to create a reader in
Python scripting. Reader objects are created in much the same way as sources
and filters; <span
class="cmtt-12">paraview.simple </span>has a function for each reader type that creates
the pipeline object and returns a <a
 id="dx1-8001"></a>proxy object. One can instantiate any
given reader directly as described below, or more simply call <span
class="cmtt-12">reader =</span>
<span
class="cmtt-12">OpenDataFile(</span><span
class="cmsy-10x-x-120">&#x27E8;</span><span
class="cmti-12">filename</span><span
class="cmsy-10x-x-120">&#x27E9;</span><span
class="cmtt-12">)</span>
<!--l. 587--><p class="indent" >   All reader objects have at least one property (hidden in the GUI) that specifies
the file name. This property is conventionally called either <span
class="cmtt-12">FileName </span>or
<span
class="cmtt-12">FileNames</span>. You should always specify a valid file name when creating a reader by
placing something like <span
class="cmtt-12">FileName=</span><span
class="cmsy-10x-x-120">&#x27E8;</span><span
class="cmti-12">full path</span><span
class="cmsy-10x-x-120">&#x27E9; </span>in the arguments of the construction
object. Readers often do not initialize correctly if not given a valid file
name.
<a
 id="x1-8002r1"></a>



<!--l. 595--><p class="noindent" ><span
class="cmbx-12x-x-120">Exercise 7.1: Creating a Reader</span> <a
 id="x1-8003"></a> <a
 id="Q1-1-16"></a>                             <br
class="newline" />We are going to start a fresh visualization, so if you have been following along
with the exercises so far, now is a good time to reset ParaView. The easiest way
to do this is to select <span
class="cmss-12">Edit </span><span
class="cmsy-10x-x-120">&#x2192; </span><span
class="cmss-12">Reset Session</span><a
 id="dx1-8004"></a> from the menu or hit <img
src="ScriptingTutorial6x.png" alt="PIC" class="graphics" width="21" height="21" ><!--tex4ht:graphics
name="ScriptingTutorial6x.png" src="images/icons/resetClock.eps"
--> on the
toolbar in paraview mode. You will also need the Python shell. If you
have not already done so, open it with <span
class="cmss-12">View </span><span
class="cmsy-10x-x-120">&#x2192; </span><span
class="cmss-12">Python Shell </span>from the
menu.
<!--l. 602--><p class="indent" >   In this exercise we are loading the <span
class="cmss-12">disk</span><span
class="cmss-12">_out</span><span
class="cmss-12">_ref.ex2 </span>file from the Python shell.
Locate this file on your computer and be ready to type or copy it into the Python
shell. We will reference it as <span
class="cmsy-10x-x-120">&#x27E8;</span><span
class="cmti-12">path</span><span
class="cmsy-10x-x-120">&#x27E9;</span><span
class="cmtt-12">/disk</span><span
class="cmtt-12">_out</span><span
class="cmtt-12">_ref.ex2</span>. You can use the file
browser to help you locate this file.
<!--l. 607--><p class="indent" >   Create the reader while specifying the file name by entering the following in
the Python shell.
<!--l. 610--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb15"><a
 id="x1-8006r1"></a><span
class="cmtt-12">reader</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;OpenDataFile(&#8217;</span><span
class="cmsy-10x-x-120">&#x27E8;</span><span
class="cmti-12">path</span><span
class="cmsy-10x-x-120">&#x27E9;</span><span
class="cmtt-12">/disk_out_ref.ex2&#8217;)</span><br class="fancyvrb" /><a
 id="x1-8008r2"></a><span
class="cmtt-12">Show()</span><br class="fancyvrb" /><a
 id="x1-8010r3"></a><span
class="cmtt-12">Render()</span><br class="fancyvrb" /><a
 id="x1-8012r4"></a><span
class="cmtt-12">ResetCamera()</span></div>
                                                                         <span
class="msam-10x-x-120">&#x2666;</span>
<!--l. 619--><p class="noindent" >
   <h3 class="sectionHead"><span class="titlemark">8   </span> <a
 id="x1-90008"></a>Querying Field Attributes</h3>
<!--l. 622--><p class="noindent" >In addition to having properties specific to the class, all proxies for pipeline
objects share a set of common properties and methods. Two very important such
properties are the <a
 id="dx1-9001"></a><a
 id="dx1-9002"></a><span
class="cmtt-12">PointData </span>and <a
 id="dx1-9003"></a><a
 id="dx1-9004"></a><span
class="cmtt-12">CellData </span>properties. These properties act like
<a
 id="dx1-9005"></a><span
class="cmbx-12">dictionaries</span>, an associative array type in Python, that maps variable names (in
strings) to <a
 id="dx1-9006"></a><a
 id="dx1-9007"></a><span
class="cmtt-12">ArrayInformation </span>objects that hold some characteristics of the
fields. Of particular note are the <a
 id="dx1-9008"></a><a
 id="dx1-9009"></a><span
class="cmtt-12">ArrayInformation </span>methods <a
 id="dx1-9010"></a><a
 id="dx1-9011"></a><span
class="cmtt-12">GetName</span>,
which returns the name of the field, <a
 id="dx1-9012"></a><a
 id="dx1-9013"></a><span
class="cmtt-12">GetNumberOfComponents</span>, which
returns the size of each field value (1 for scalars, more for vectors), and
<a
 id="dx1-9014"></a><a
 id="dx1-9015"></a><span
class="cmtt-12">GetRange</span>, which returns the minimum and maximum values for a particular
component.
<a
 id="x1-9016r1"></a>



<!--l. 635--><p class="noindent" ><span
class="cmbx-12x-x-120">Exercise 8.1: Getting Field Information</span> <a
 id="x1-9017"></a> <a
 id="Q1-1-18"></a>                   <br
class="newline" />This exercise is a continuation of Exercise&#x00A0;<a
href="#x1-8002r1">7.1<!--tex4ht:ref: ex:CreatingAReader --></a>. You will need to finish that
exercise before beginning this one.
<!--l. 640--><p class="indent" >   To start with, get a handle to the point data and print out all of the point
fields available.
   <div class="fancyvrb" id="fancyvrb16"><a
 id="x1-9019r1"></a><span
class="cmtt-12">pd</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;reader.PointData</span><br class="fancyvrb" /><a
 id="x1-9021r2"></a><span
class="cmtt-12">print</span><span
class="cmtt-12">&#x00A0;pd.keys()</span></div>
<!--l. 647--><p class="indent" >   Get some information about the &#8220;Pres&#8221; and &#8220;V&#8221; fields.
   <div class="fancyvrb" id="fancyvrb17"><a
 id="x1-9023r1"></a><span
class="cmtt-12">print</span><span
class="cmtt-12">&#x00A0;pd[&#8217;Pres&#8217;].GetNumberOfComponents()</span><br class="fancyvrb" /><a
 id="x1-9025r2"></a><span
class="cmtt-12">print</span><span
class="cmtt-12">&#x00A0;pd[&#8217;Pres&#8217;].GetRange()</span>
<br class="fancyvrb" /><a
 id="x1-9027r3"></a><span
class="cmtt-12">print</span><span
class="cmtt-12">&#x00A0;pd[&#8217;V&#8217;].GetNumberOfComponents()</span></div>
<!--l. 654--><p class="indent" >   Now let us get fancy. Use the Python <span
class="cmtt-12">for </span>construct to iterate over all of the
arrays and print the ranges for all the components.
   <div class="fancyvrb" id="fancyvrb18"><a
 id="x1-9029r1"></a><span
class="cmtt-12">for</span><span
class="cmtt-12">&#x00A0;ai</span><span
class="cmtt-12">&#x00A0;in</span><span
class="cmtt-12">&#x00A0;pd.values():</span><br class="fancyvrb" /><a
 id="x1-9031r2"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;print</span><span
class="cmtt-12">&#x00A0;ai.GetName(),</span><span
class="cmtt-12">&#x00A0;ai.GetNumberOfComponents(),</span>
<br class="fancyvrb" /><a
 id="x1-9033r3"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;for</span><span
class="cmtt-12">&#x00A0;i</span><span
class="cmtt-12">&#x00A0;in</span><span
class="cmtt-12">&#x00A0;xrange(ai.GetNumberOfComponents()):</span><br class="fancyvrb" /><a
 id="x1-9035r4"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;print</span><span
class="cmtt-12">&#x00A0;ai.GetRange(i),</span><br class="fancyvrb" /><a
 id="x1-9037r5"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;print</span></div>
                                                                         <span
class="msam-10x-x-120">&#x2666;</span>
<!--l. 666--><p class="noindent" >
   <h3 class="sectionHead"><span class="titlemark">9   </span> <a
 id="x1-100009"></a>Representations</h3>
<a
 id="dx1-10001"></a>
<!--l. 670--><p class="noindent" >Representations are the &#8220;glue&#8221; between the data in a pipeline object and a view.
The representation is responsible for managing how a data set is drawn in the
view. The representation defines and manages the underlying rendering objects
used to draw the data as well as other rendering properties such as coloring and
lighting. Parameters made available in the <span
class="cmss-12">Display </span>group of the GUI are managed
by representations. There is a separate representation object instance for every
pipeline-object&#8211;view pair. This is so that each view can display the data
differently.
<!--l. 679--><p class="indent" >   Representations are created automatically by the GUI. In python scripting
they are created with the <a
 id="dx1-10002"></a><a
 id="dx1-10003"></a><span
class="cmtt-12">Show </span>function instead. In fact <span
class="cmtt-12">Show </span>returns a <a
 id="dx1-10004"></a>proxy to
the representation. Therefore you can save <a
 id="dx1-10005"></a><a
 id="dx1-10006"></a><span
class="cmtt-12">Show</span>&#8217;s return value in a variable as



we&#8217;ve done above for sources, filters and readers. If you neglect to save it, you can
always get it back with the <a
 id="dx1-10007"></a><a
 id="dx1-10008"></a><span
class="cmtt-12">GetRepresentation </span>function. With no arguments,
this function will return the representation for the active pipeline object
and the active view. You can also specify a pipeline object or view or
both.
<a
 id="x1-10009r1"></a>
<!--l. 690--><p class="noindent" ><span
class="cmbx-12x-x-120">Exercise 9.1: Coloring Data</span> <a
 id="x1-10010"></a> <a
 id="Q1-1-20"></a>                                   <br
class="newline" />This exercise is a continuation of Exercise&#x00A0;<a
href="#x1-8002r1">7.1<!--tex4ht:ref: ex:CreatingAReader --></a> (and optionally Exercise&#x00A0;<a
href="#x1-9016r1">8.1<!--tex4ht:ref: ex:GettingFieldInformation --></a>). If
you do not have the exodus file open, you will need to finish Exercise&#x00A0;<a
href="#x1-8002r1">7.1<!--tex4ht:ref: ex:CreatingAReader --></a> before
beginning this one.
<!--l. 697--><p class="indent" >   Let us change the color of the geometry to blue and give it a very pronounced
specular highlight<a
 id="dx1-10011"></a> (that is, make it really <a
 id="dx1-10012"></a>shiny). Type in the following
into the Python shell to get the representation and change the material
properties.
<!--l. 702--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb19"><a
 id="x1-10014r1"></a><span
class="cmtt-12">readerRep</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;GetRepresentation()</span><br class="fancyvrb" /><a
 id="x1-10016r2"></a><span
class="cmtt-12">readerRep.DiffuseColor</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;[0,</span><span
class="cmtt-12">&#x00A0;0,</span><span
class="cmtt-12">&#x00A0;1]</span>
<br class="fancyvrb" /><a
 id="x1-10018r3"></a><span
class="cmtt-12">readerRep.SpecularColor</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;[1,</span><span
class="cmtt-12">&#x00A0;1,</span><span
class="cmtt-12">&#x00A0;1]</span><br class="fancyvrb" /><a
 id="x1-10020r4"></a><span
class="cmtt-12">readerRep.SpecularPower</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;128</span>
<br class="fancyvrb" /><a
 id="x1-10022r5"></a><span
class="cmtt-12">readerRep.Specular</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;1</span><br class="fancyvrb" /><a
 id="x1-10024r6"></a><span
class="cmtt-12">Render()</span></div>
<!--l. 711--><p class="indent" >   Now rotate the camera with the mouse in the GUI to see the effect of the
specular highlighting.
<!--l. 714--><p class="indent" >   We can also use the representation to color by a field variable. There is
actually quite a bit of state that must be set to change field variables. The
<a
 id="dx1-10025"></a><a
 id="dx1-10026"></a><a
 id="dx1-10027"></a><a
 id="dx1-10028"></a><span
class="cmtt-12">ColorBy </span>function provides a simple interface to color a mesh by a field value. A
subsequent call to <a
 id="dx1-10029"></a><a
 id="dx1-10030"></a><a
 id="dx1-10031"></a><a
 id="dx1-10032"></a><span
class="cmtt-12">UpdateScalarBars </span>also updates the color bar annotation.
Enter the following into the Python shell to color the mesh by the &#8220;Pres&#8221; field
variable.
<!--l. 720--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb20"><a
 id="x1-10034r1"></a><span
class="cmtt-12">ColorBy(readerRep,</span><span
class="cmtt-12">&#x00A0;(&#8217;POINTS&#8217;,</span><span
class="cmtt-12">&#x00A0;&#8217;Pres&#8217;))</span><br class="fancyvrb" /><a
 id="x1-10036r2"></a><span
class="cmtt-12">UpdateScalarBars()</span><br class="fancyvrb" /><a
 id="x1-10038r3"></a><span
class="cmtt-12">Render()</span></div>
                                                                         <span
class="msam-10x-x-120">&#x2666;</span>



<!--l. 727--><p class="noindent" >
   <h3 class="sectionHead"><span class="titlemark">10   </span> <a
 id="x1-1100010"></a>Views</h3>
<a
 id="dx1-11001"></a>
<!--l. 731--><p class="noindent" >Drawing areas or windows are called Views in ParaView. As with readers, sources,
filters, and representations, views are wrapped into python objects and these can
be created, obtained and controlled via scripts.
<!--l. 735--><p class="indent" >   Views are usually created for you by the GUI, but in python you have to
create views more intentionally. The most convenient way to do so is to rely on
the way that <a
 id="dx1-11002"></a><a
 id="dx1-11003"></a><span
class="cmtt-12">Render </span>returns a view, creating one first if necessary. If you prefer,
you can create specific view types via <a
 id="dx1-11004"></a><a
 id="dx1-11005"></a><span
class="cmtt-12">CreateView(&#8217;</span><span
class="cmsy-10x-x-120">&#x27E8;</span><span
class="cmti-12">viewname</span><span
class="cmsy-10x-x-120">&#x27E9;</span><span
class="cmtt-12">&#8217;) </span>or
<a
 id="dx1-11006"></a><a
 id="dx1-11007"></a><span
class="cmtt-12">CreateRenderView</span>, <a
 id="dx1-11008"></a><a
 id="dx1-11009"></a><span
class="cmtt-12">CreateXYPlotView </span>and the like. However you make them,
call <a
 id="dx1-11010"></a><a
 id="dx1-11011"></a><span
class="cmtt-12">GetRenderViews </span>to get a list of all Views, or <a
 id="dx1-11012"></a><a
 id="dx1-11013"></a><span
class="cmtt-12">GetActiveView </span>get access to the
currently active view. There is also a function named <a
 id="dx1-11014"></a><a
 id="dx1-11015"></a><span
class="cmtt-12">GetRenderView </span>(no &#8216;s&#8217; on
the end) that that gets the active view if there is one or creates a new one if there
is no active view.
<!--l. 747--><p class="indent" >   Once you have a view you have access to all of the properties that you see on
the <span
class="cmss-12">View </span>group of the GUI. For instance you can easily turn on and off the
orientation widget, change the background color, alter the lighting and more.
Besides these first level properties, the view also gives you access to other scene
wide controls such as the camera, animation time, and when not running
alongside the GUI, the view&#8217;s size.
<a
 id="x1-11016r1"></a>
<!--l. 751--><p class="noindent" ><span
class="cmbx-12x-x-120">Exercise 10.1: Controlling the View</span> <a
 id="x1-11017"></a> <a
 id="Q1-1-22"></a>                        <br
class="newline" />This exercise is a continuation of Exercise&#x00A0;<a
href="#x1-8002r1">7.1<!--tex4ht:ref: ex:CreatingAReader --></a> (and optionally Exercises&#x00A0;<a
href="#x1-9016r1">8.1<!--tex4ht:ref: ex:GettingFieldInformation --></a>
and&#x00A0;<a
href="#x1-10009r1">9.1<!--tex4ht:ref: ex:ColoringData --></a>). If you do not have the exodus file open, you will need to finish
Exercise&#x00A0;<a
href="#x1-8002r1">7.1<!--tex4ht:ref: ex:CreatingAReader --></a> before beginning this one.
<!--l. 759--><p class="indent" >   Let us change the background color of the scene from ParaView&#8217;s default gray
to a nice gradient instead. Type the following into the Python shell to get a hold
of the View and change it.
<!--l. 763--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb21"><a
 id="x1-11019r1"></a><span
class="cmtt-12">view</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;GetActiveView()</span><br class="fancyvrb" /><a
 id="x1-11021r2"></a><span
class="cmtt-12">view.Background</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;[0,</span><span
class="cmtt-12">&#x00A0;0,</span><span
class="cmtt-12">&#x00A0;0]</span>
<br class="fancyvrb" /><a
 id="x1-11023r3"></a><span
class="cmtt-12">view.Background2</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;[0,</span><span
class="cmtt-12">&#x00A0;0,</span><span
class="cmtt-12">&#x00A0;0.6]</span><br class="fancyvrb" /><a
 id="x1-11025r4"></a><span
class="cmtt-12">view.UseGradientBackground</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;True</span><br class="fancyvrb" /><a
 id="x1-11027r5"></a><span
class="cmtt-12">Render()</span></div>
<!--l. 771--><p class="indent" >   Next, let us ask the view what position the camera is sitting at, and then move
it within a for loop to create a short animation.



   <div class="fancyvrb" id="fancyvrb22"><a
 id="x1-11029r1"></a><span
class="cmtt-12">x,y,z</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;view.CameraPosition</span><br class="fancyvrb" /><a
 id="x1-11031r2"></a><span
class="cmtt-12">print</span><span
class="cmtt-12">&#x00A0;x,y,z</span><br class="fancyvrb" /><a
 id="x1-11033r3"></a><span
class="cmtt-12">for</span><span
class="cmtt-12">&#x00A0;iter</span><span
class="cmtt-12">&#x00A0;in</span><span
class="cmtt-12">&#x00A0;xrange(0,10):</span><br class="fancyvrb" /><a
 id="x1-11035r4"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;x</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;x</span><span
class="cmtt-12">&#x00A0;+</span><span
class="cmtt-12">&#x00A0;1</span>
<br class="fancyvrb" /><a
 id="x1-11037r5"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;y</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;y</span><span
class="cmtt-12">&#x00A0;+</span><span
class="cmtt-12">&#x00A0;1</span><br class="fancyvrb" /><a
 id="x1-11039r6"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;z</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;z</span><span
class="cmtt-12">&#x00A0;+</span><span
class="cmtt-12">&#x00A0;1</span><br class="fancyvrb" /><a
 id="x1-11041r7"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;view.CameraPosition</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;[x,y,z]</span><br class="fancyvrb" /><a
 id="x1-11043r8"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;print</span><span
class="cmtt-12">&#x00A0;x,y,z</span><br class="fancyvrb" /><a
 id="x1-11045r9"></a><span
class="cmtt-12">&#x00A0;</span><span
class="cmtt-12">&#x00A0;Render()</span></div>
                                                                         <span
class="msam-10x-x-120">&#x2666;</span>
<!--l. 788--><p class="noindent" >
   <h3 class="sectionHead"><span class="titlemark">11   </span> <a
 id="x1-1200011"></a>Saving Results</h3>
<a
 id="dx1-12001"></a>
<!--l. 792--><p class="noindent" >Within a script it is easy to save out results, and by saving your data and
your scripts it becomes easy to create reproducible visualization with
ParaView.
<!--l. 796--><p class="indent" >   As within the GUI, there are several products that you might like to save out
when you are working with ParaView.
      <ul class="itemize1">
      <li class="itemize">To save out the data produced by a filter, add a writer to the filter with
      the desired filename using the <a
 id="dx1-12002"></a><a
 id="dx1-12003"></a><span
class="cmtt-12">CreateWriter </span>function and then update
      the writer proxy with the <span
class="cmtt-12">UpdatePipeline </span>method. This is analogous
      to clicking on a pipeline element and selecting <span
class="cmss-12">File </span><span
class="cmsy-10x-x-120">&#x2192; </span><span
class="cmss-12">Save Data</span>.
      </li>
      <li class="itemize">Saving        images        is        as        simple        as        typing
      <span
class="cmtt-12">SaveScreenshot(&#8217;</span><span
class="cmsy-10x-x-120">&#x27E8;</span><span
class="cmti-12">path</span><span
class="cmsy-10x-x-120">&#x27E9;</span><span
class="cmtt-12">/filename.still</span><span
class="cmtt-12">_extension&#8217;)</span>.
      </li>
      <li class="itemize">Assuming your ParaView is linked to an encoder and codecs, saving
      compressed      animations      is      as      simple      as      typing
      <span
class="cmtt-12">WriteAnimation(&#8217;</span><span
class="cmsy-10x-x-120">&#x27E8;</span><span
class="cmti-12">path</span><span
class="cmsy-10x-x-120">&#x27E9;</span><span
class="cmtt-12">/filename.animation</span><span
class="cmtt-12">_extension&#8217;)</span>.</li></ul>
<!--l. 809--><p class="noindent" >In all cases ParaView uses the file name extension to determine the specific file type
to create.
<a
 id="x1-12004r1"></a>



<!--l. 812--><p class="noindent" ><span
class="cmbx-12x-x-120">Exercise 11.1: Save Results</span> <a
 id="x1-12005"></a> <a
 id="Q1-1-24"></a>                                   <br
class="newline" />This exercise is a continuation of Exercise&#x00A0;<a
href="#x1-8002r1">7.1<!--tex4ht:ref: ex:CreatingAReader --></a> (and optionally Exercises <a
href="#x1-9016r1">8.1<!--tex4ht:ref: ex:GettingFieldInformation --></a>
through <a
href="#x1-11016r1">10.1<!--tex4ht:ref: ex:ControlView --></a>). If you do not have the exodus file open, you will need to finish
Exercise&#x00A0;<a
href="#x1-8002r1">7.1<!--tex4ht:ref: ex:CreatingAReader --></a> before beginning this one.
<!--l. 820--><p class="indent" >   Let us first probe the data to get something compact out of it. Then we will
save out the result of the probe in the form of a comma separated values file so
that we can look at it in a text editor and import it into any other tool we
choose.
<!--l. 822--><p class="indent" >
   <div class="fancyvrb" id="fancyvrb23"><a
 id="x1-12007r1"></a><span
class="cmtt-12">plot</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;PlotOverLine()</span><br class="fancyvrb" /><a
 id="x1-12009r2"></a><span
class="cmtt-12">plot.Source.Point1</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;[0,0,0]</span><br class="fancyvrb" /><a
 id="x1-12011r3"></a><span
class="cmtt-12">plot.Source.Point2</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;[0,0,10]</span>
<br class="fancyvrb" /><a
 id="x1-12013r4"></a><span
class="cmtt-12">writer</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;CreateWriter(&#8217;</span><span
class="cmsy-10x-x-120">&#x27E8;</span><span
class="cmti-12">path</span><span
class="cmsy-10x-x-120">&#x27E9;</span><span
class="cmtt-12">/plot.csv&#8217;)</span><br class="fancyvrb" /><a
 id="x1-12015r5"></a><span
class="cmtt-12">writer.UpdatePipeline()</span></div>
<!--l. 830--><p class="indent" >   Next, lets create a <span
class="cmss-12">LineChartView </span>to show the plot in and then save out a
screenshot of our results.
   <div class="fancyvrb" id="fancyvrb24"><a
 id="x1-12017r1"></a><span
class="cmtt-12">plotView</span><span
class="cmtt-12">&#x00A0;=</span><span
class="cmtt-12">&#x00A0;CreateView(&#8217;XYChartView&#8217;)</span><br class="fancyvrb" /><a
 id="x1-12019r2"></a><span
class="cmtt-12">Show(plot)</span><br class="fancyvrb" /><a
 id="x1-12021r3"></a><span
class="cmtt-12">Render()</span>
<br class="fancyvrb" /><a
 id="x1-12023r4"></a><span
class="cmtt-12">SaveScreenshot(&#8217;</span><span
class="cmsy-10x-x-120">&#x27E8;</span><span
class="cmti-12">path</span><span
class="cmsy-10x-x-120">&#x27E9;</span><span
class="cmtt-12">/plot.png&#8217;)</span></div>
                                                                         <span
class="msam-10x-x-120">&#x2666;</span>
<!--l. 839--><p class="indent" >   As you can see, ParaView&#8217;s scripting interface is quite powerful, and once you
know the fundamentals and are familiar with Python&#8217;s syntax, it is fairly easy to
get up and running with it. We have just touched on the higher level aspects of
ParaView scriptability in this tutorial. More details, including how to run python
scripted filters, how to work with numpy and other tools, and how to package
your scripts for execution under batch schedulers can be found online.
<a
 id="dx1-12024"></a>

</body></html>
